#include <QApplication>
#include "global.h"

	QHash<QString, QString> workValue;
	QHash<QString, QString> defValue;
	QVector<OkProfile> profiles;
	QPoint clickPos;
	bool compositeEnabled;
	QString configFile;
	QLabel *slPic, *olPic, *clPic, *fgPic, *bgPic;
	QVector<itemType> items;
	QPixmap *shadowPic, *overPic, *backgroundPic, *foregroundPic;
	QEasingCurve animTypeMove, animTypeCenter, animTypeFade;
	QGraphicsScene *scene;
	QGraphicsView *view;
	QProcess *itemProc;
	bool debug;

// Строка в двоичное
bool strToBool (QString b){
	bool bb;
	if (b.toUpper() == "TRUE") {bb=true;}
		else {bb=false;}
	return bb;
}

// Преобразование строки, содержащей параметры цвета "R,G,B,A" в QColor
QColor strToColor(QString strColor){
	QColor color (strColor.section (",",0,0).toInt(), strColor.section (",",1,1).toInt(), strColor.section (",",2,2).toInt(), strColor.section (",",3,3).toInt());
	return color;
}

// Преобразование QColor в строку "R,G,B,A"
QString strFromColor(QColor color){
	QString str=QString::number (color.red())+","+QString::number (color.green())+","+QString::number (color.blue())+","+QString::number (color.alpha());
	return str;
}

// Строка в целое
int strToInt(QString Str, long Alternative){
	bool ok;
	long a=Str.toInt (&ok);
	if (ok) return a;
	else return Alternative;
}

// Получение значения из массива
QString getValue (QString profile, QString parameter, QString valuedef){
	OkProfile pr=getProfile (profile);
	QString value=valuedef;
	int i=pr.parameters.indexOf (parameter);
	if (i>-1) value=pr.values[i];
	return value;
}

// Получение профиля из массива
OkProfile getProfile (QString pr){
	OkProfile profile;
	for (int i=0;i<profiles.size();i++)
		if (profiles[i].name == pr) profile=profiles[i];
	return profile;
}

int calcHPosition (QString value, int width, int offset){
	int left=0;
// Begin patch for multi-screen (Andreas Fink <andreas.fink85@googlemail.com>)
	QRect screen = QApplication::desktop()->screenGeometry(QCursor::pos());
	if (value.toUpper() == "LEFT") left=screen.left()+offset;
		else if (value.toUpper() == "RIGHT") left=screen.right()-width-offset;
			else if (value.toUpper() == "CENTER") left=screen.center().x()-width/2;
				else left=value.toInt();
// End patch
	return left;
}

int calcVPosition (QString value, int height, int offset){
	int top=0;
// Begin patch for multi-screen (Andreas Fink <andreas.fink85@googlemail.com>)
	QRect screen = QApplication::desktop()->screenGeometry(QCursor::pos());
	if (value.toUpper() == "TOP") top=screen.top()+offset;
		else if (value.toUpper() == "BOTTOM") top=screen.bottom()-height-offset;
			else if (value.toUpper() == "CENTER") top=screen.center().y()-height/2;
				else top=value.toInt();
// End patch
	return top;
}

void setConfigValue (QString profile, QString parameter){
	workValue[parameter]=getValue (profile,parameter,defValue[parameter]);
}

QStringList strToArgs (QString str){
	QString st=str+" ";
	QStringList sl;
	QString word="";
	bool endQuote=false;
	for (int i=0;i<st.length();i++){
		if (st[i] == '\"' && st[i-1] !='\\') endQuote=!endQuote;
		if (st[i] == ' ' && !endQuote) {
			if (word != "") sl.append (word);
			word="";
			}
		else {
			if (st[i] != '\"') word=word+st[i];
			if (st[i] == '\"' && st[i-1] =='\\') word=word+st[i];
			}
	}
	return sl;
}

QVariant dbusCall (QString str){
	QStringList dbus=strToArgs (str);
	QList<QVariant> param;
	for (int j=3;j<dbus.size();j++) param<< dbus[j];
if (debug) qDebug()<<"--------------------------------------------------------------------";
if (debug) qDebug()<<"dbusCall:";
if (debug) qDebug()<<"Service:    "<<dbus[0];
if (debug) qDebug()<<"Interface:  "<<dbus[1];
if (debug) qDebug()<<"Method:     "<<dbus[2];
if (debug) qDebug()<<"Parameters: "<<param;
	QDBusInterface interface (dbus[0], dbus[1]);
	QVariant ret;
	QDBusReply<QVariant> reply = interface.callWithArgumentList (QDBus::Block, dbus[2], param);
if (debug) qDebug()<<"isValid:    "<<reply.isValid();
	if (reply.isValid()) ret=reply;
	else {
		QDBusMessage mess = interface.callWithArgumentList (QDBus::Block, dbus[2], param);
if (debug) qDebug()<<"Error mess: "<<mess.errorMessage();
		ret = mess.arguments()[0];
		}
if (debug) qDebug()<<"Return:     "<<ret;
if (debug) qDebug()<<"--------------------------------------------------------------------";
	return ret;
}

void dbusServiceRegister (QString interface, QObject *parent){
	QDBusConnection dbusConnection = QDBusConnection (QDBusConnection::sessionBus());
	dbusConnection.connectToBus(QDBusConnection::SessionBus, "org.kochkin.okindd");
	if (!dbusConnection.registerService("org.kochkin.okindd")) {
		qDebug()<<"Service not registered. May be already running";
		}
	if (!dbusConnection.registerObject("/"+interface, parent, QDBusConnection::ExportAllSlots)) {
		qDebug()<<"Object /"<<interface<<" not registered.";
		}
}

void saveParameterToConfig (QString section, QString parameter, QVariant value){
	QSettings cfg (configFile, QSettings::NativeFormat);
	cfg.setIniCodec ("UTF-8");
	cfg.beginGroup (section);
	cfg.setValue (parameter, value);
	cfg.endGroup();
	cfg.sync();
}

QVariant loadParameterFromConfig (QString section, QString parameter){
	QSettings cfg (configFile, QSettings::NativeFormat);
	cfg.setIniCodec ("UTF-8");
	cfg.beginGroup (section);
	QVariant value = cfg.value (parameter);
	cfg.endGroup();
	return value;
}
