#ifndef __GLOBAL_H__
#define __GLOBAL_H__

#include <QHash>
#include <QVariant>
#include <QVector>
#include <QColor>
#include <QPoint>
#include <QDebug>
#include <QDesktopWidget>
#include <QX11Info>
#include <QtDBus>
#include <QLabel>
#include <QGraphicsScene>
#include <QGraphicsView>

struct OkProfile {
	QString name;
	QStringList parameters;
	QStringList values;
	};

struct itemType {
	QString description;
	QPixmap picture;
	QString command;
	QString dbusCall;
};

extern bool debug;
extern QProcess *itemProc;
extern QGraphicsScene *scene;
extern QGraphicsView *view;
extern QEasingCurve animTypeMove, animTypeCenter, animTypeFade;
extern QPixmap *shadowPic, *overPic, *backgroundPic, *foregroundPic;
extern QVector<itemType> items;
extern QLabel *slPic, *olPic, *clPic, *fgPic, *bgPic;
extern QString configFile;
extern bool compositeEnabled;	
extern QVector<OkProfile> profiles;
extern QHash<QString, QString> workValue;
extern QHash<QString, QString> defValue;
extern bool strToBool (QString b);
extern QColor strToColor(QString strColor);
extern int strToInt(QString Str, long Alternative);
extern QString strFromColor(QColor color);
extern QString getValue (QString profile, QString parameter, QString valuedef);
extern OkProfile getProfile (QString pr);
extern QPoint clickPos;
extern int calcHPosition (QString value, int width, int offset);
extern int calcVPosition (QString value, int height, int offset);
extern void setConfigValue (QString profile, QString parameter);
extern QStringList strToArgs (QString str);
extern QVariant dbusCall (QString str);
extern void dbusServiceRegister (QString interface, QObject *parent);
extern void saveParameterToConfig (QString section, QString parameter, QVariant value);
extern QVariant loadParameterFromConfig (QString section, QString parameter);

#endif // __GLOBAL_H__
