#ifndef __OKINDD_H__
#define __OKINDD_H__

#include "build_number.h"
#define VERSION VERSION_NUMBER"-"BUILD_NUMBER

#include "roundIndicator.h"
#include "picture.h"
#include "text.h"
#include "menu.h"
#include "global.h"
#include <QApplication>
#include <QLabel>
#include <QtDBus>
#include <QDir>
#include <QBitmap>
#include <QDesktopWidget>
#include <QPainter>
#include <QPicture>
#include <QAbstractButton>

class service: public QDBusAbstractAdaptor{
Q_OBJECT
Q_CLASSINFO("D-Bus Interface", "org.kochkin.okindd")

public:
	service(QApplication *application);
	~service();

	roundIndicator * roundInd;
	pic * pict;
	textObject *text;
	menuObject *menu;
	QTimer *repeatTimer;
	
	void fdisplay (QString profile, int value);
	void getProfiles();

	QString HomeDir, currentProfile;
	QDir home;
private slots:
	void profileChanged();
public slots:
	void exit();
	void display (QString profile, int value);
	void setConfigFile (QString confFile);
	void remote (QString profile, QString action);
	void loadProfileFromArray (QString pr);
	void resetToDefault();
	QString getCurrentConfigFile();
	QString getCurrentProfile();
	QString getVersion();
	QString getCurrentDateTime (QString format);
};
#endif // __OKINDD_H__
