#ifndef ROUNDINDICATOR_H
#define ROUNDINDICATOR_H

#include <QLabel>
#include <QMouseEvent>
#include <QDesktopWidget>
#include <QPainter>
#include "math.h"
#include <QBitmap>
#include <QImage>
#include <QDebug>
#include <QtDBus>
#include <QGraphicsBlurEffect>
#include "global.h"

class roundIndicator : public QLabel{
Q_OBJECT
Q_CLASSINFO("D-Bus Interface", "org.kochkin.okindd")
public:
	roundIndicator (QLabel * parent = 0);
	virtual ~roundIndicator();

	void setDigitsFont(QString name, bool bold, bool italic);
	int getCenterDiameter(QString centerDiameter);
	void showCurrent (int value);

	QPixmap picture, shadow;
	int centerDiameter, diameter, fullDiameter, offset;
	int posVert, posHor;
	int angle, animationFPS, animationPass;
	int valueMin, valueMax, currentValue, prevValue;
	QColor colorULB,colorBRB,colorULI,colorBRI,colorULC,colorBRC, colorDigits, colorDigitsShadow;
	bool digitsEnabled;
	QFont digitsFont;
	float opacity;
	QTimer *time, *animationTimer;
	float anglePos, prevAngle, valueOut, animationX;
	int angleLength, valueRange, angleBegin;
private:
	virtual void mousePressEvent (QMouseEvent *e);
	virtual void mouseMoveEvent (QMouseEvent *e);
	virtual void mouseReleaseEvent (QMouseEvent *);
	virtual void paintEvent (QPaintEvent *);
private slots:
	void nextStepAnimation();
	void setPosition (QString hPosition, QString vPosition);
	void setDiameter (int Diameter);
	void setAngle (int Angle);
	void setOpacity (QString Opacity);
	void showIndicator();
	void hideIndicator();
	QVariant getValueFromDBUS(QVariant altValue);
	void workValuesToCurrent ();

public slots:
	void Indicator (QString File, QString Left, QString Top, QString Diameter, QString Angle, int value, int Time);
};
#endif
